// handscounter.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include <shellapi.h>
#include <commctrl.h>
#include "handscounter.h"

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
static void HAndleNotifyMessage(HWND hWnd, LPARAM lParam);

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

	HANDLE hMutex = CreateMutex(NULL, TRUE, "920798ef-b598-4b14-af03-772389cebdf9");
	if ((hMutex != NULL) && GetLastError() == ERROR_ALREADY_EXISTS) {
		CloseHandle(hMutex);
		return 1;
	}

 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_HANDSCOUNTER, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_HANDSCOUNTER));

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	CloseHandle(hMutex);

	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_HANDSCOUNTER));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_HANDSCOUNTER);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HINSTANCE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, 0,//WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

//   ShowWindow(hWnd, nCmdShow);
//   UpdateWindow(hWnd);
   NOTIFYICONDATA notifyData;
   memset(&notifyData, 0, sizeof(notifyData));
   notifyData.cbSize = sizeof(notifyData);
   notifyData.hWnd = hWnd;
   notifyData.uID = 1234;
   notifyData.uFlags = NIF_MESSAGE | NIF_ICON| NIF_TIP;
   notifyData.uCallbackMessage = WM_USER;
   notifyData.dwStateMask = NIS_HIDDEN;
   notifyData.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_HANDSCOUNTER));
   lstrcpy(notifyData.szTip, "Hands Counter");
   Shell_NotifyIcon(NIM_ADD, &notifyData);

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;

	switch (message)
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_EXIT:
			{
				NOTIFYICONDATA notifyData;
				memset(&notifyData, 0, sizeof(notifyData));
				notifyData.cbSize = sizeof(notifyData);
				notifyData.hWnd = hWnd;
				notifyData.uID = 1234;
				Shell_NotifyIcon(NIM_DELETE, &notifyData);
			}
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	case WM_USER:
		HAndleNotifyMessage(hWnd, lParam);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

struct enum_param {
	char *title;
	int count;
	bool success;
};

static BOOL CALLBACK EnumPalUserList(HWND hwnd, LPARAM lParam)
{
	CHAR str[256];
	if (!GetClassName(hwnd, str, sizeof(str)))
		return TRUE;
	if (lstrcmp(str, "SysListView32") != 0)
		return TRUE;
	DWORD procId;
	GetWindowThreadProcessId(hwnd, &procId);
	HANDLE hProcess = OpenProcess(
		PROCESS_VM_OPERATION  |
		PROCESS_VM_READ |
		PROCESS_VM_WRITE, FALSE, procId);
	if (hProcess != NULL) {
		VOID *p = VirtualAllocEx(hProcess, NULL, sizeof(LVITEM),
			MEM_COMMIT | MEM_RESERVE, PAGE_READWRITE);
		if (p != NULL) {
			int index, nitems = ListView_GetItemCount(hwnd);
			enum_param *pep = (enum_param *) lParam;
			pep->success = true;
			pep->count = 0;
			LVITEM lvitem;
			for (index = 0; index < nitems; ++index) {
				lvitem.mask = LVIF_IMAGE;
				lvitem.iItem = index;
				lvitem.iSubItem = 1;
				if (!WriteProcessMemory(hProcess, p, &lvitem, sizeof(lvitem), NULL))
					break;
				if (!ListView_GetItem(hwnd, p))
					break;
				if (!ReadProcessMemory(hProcess, p, &lvitem, sizeof(lvitem), NULL))
					break;
				if (lvitem.iImage == 5)
					++pep->count;
			}
			VirtualFreeEx(hProcess, p, 0, MEM_RELEASE);
		}
		CloseHandle(hProcess);
	}
	return FALSE;
}

static BOOL CALLBACK EnumPalRooms(HWND hwnd, LPARAM lParam)
{
	CHAR str[256];
	if (!GetClassName(hwnd, str, sizeof(str)))
		return TRUE;
	if (lstrcmp(str, "DlgGroupChat Window Class") != 0)
		return TRUE;
	if (GetWindowText(hwnd, str, sizeof(str)) == 0)
		return TRUE;
	char *s = strstr(str, " - Voice Room");
	if (s == NULL)
		return TRUE;
	EnumChildWindows(hwnd, EnumPalUserList, lParam);
	enum_param *pep = (enum_param *) lParam;
	if (pep->success) {
		*s = '\0';
		if (lstrlen(str) >= 63) {
			str[62] = '';
			str[63] = '\0';
		}
		lstrcpy(pep->title, str);
	}
	return FALSE;
}

static bool CountRoomHands(LPSTR title, int *count)
{
	enum_param ep;
	ep.title = title;
	ep.success = false;
	EnumWindows(EnumPalRooms, LPARAM(&ep));
	if (ep.success)
		*count = ep.count;
	return ep.success;
}

static void HAndleNotifyMessage(HWND hWnd, LPARAM lParam)
{
	switch (lParam) {
		case WM_LBUTTONDOWN:
			{
				int count;
				NOTIFYICONDATA notifyData;
				memset(&notifyData, 0, sizeof(notifyData));
				notifyData.cbSize = sizeof(notifyData);
				if (CountRoomHands(notifyData.szInfoTitle, &count)) {
					notifyData.hWnd = hWnd;
					notifyData.uID = 1234;
					notifyData.uFlags = NIF_INFO;
					wsprintf(notifyData.szInfo, "Hands up: %d", count);
					notifyData.uTimeout = 5;
					Shell_NotifyIcon(NIM_MODIFY, &notifyData);
				}
			}
			break;
		case WM_RBUTTONDOWN:
			{
				HMENU hSubMenu = GetSubMenu(GetMenu(hWnd), 0);
				POINT pt;
				GetCursorPos(&pt);
				SetForegroundWindow(hWnd);
				TrackPopupMenu(hSubMenu, TPM_RIGHTBUTTON, pt.x, pt.y, 0, hWnd, NULL);
				PostMessage(hWnd, WM_NULL, 0, 0);
			}
			break;
	}
}
